function f=bargaining_estimation_objective_function(channel_bargaining_parameters,channel,input_cost,bargaining_parameters,regulation_option,preferences,conglomerate_parameters,knitro)

conglomerate=conglomerate_parameters{1};
conglomerate_groups=conglomerate_parameters{2};
channel_to_conglomerate=conglomerate_parameters{3};

channel_bargaining_parameters=reshape(channel_bargaining_parameters,1,4);
disp(channel_bargaining_parameters)

if ((min(channel_bargaining_parameters)>0.001) && (max(channel_bargaining_parameters)<.999))

    if (conglomerate==0)
        bargaining_parameters(channel,:)=channel_bargaining_parameters;
    else
        bargaining_parameters(conglomerate_groups{channel_to_conglomerate(channel)},:)=repmat(channel_bargaining_parameters,length(conglomerate_groups{channel_to_conglomerate(channel)}),1);
    end
    
bundles=ones(size(input_cost));

try 
    load last_input_cost
    if (corresponding_channel~=channel)
        last_input_cost=input_cost;
    end
catch
    last_input_cost=input_cost;
end



if (conglomerate==0)
test_input_costs=bargaining_equilibrium(channel,last_input_cost,bundles,bargaining_parameters,regulation_option,preferences,conglomerate_parameters);

last_input_cost=test_input_costs;
corresponding_channel=channel;
save last_input_cost last_input_cost corresponding_channel

if (knitro==0)
pre_f=input_cost(channel,:)-test_input_costs(channel,:);
f=pre_f*pre_f';
elseif (knitro==1)
f=input_cost(channel,:)-test_input_costs(channel,:);  
end
disp ([input_cost(channel,:); test_input_costs(channel,:)])

else
    
    list_of_conglomerate_channels=conglomerate_groups{channel_to_conglomerate(channel)};
    
    test_input_costs=bargaining_equilibrium(channel,last_input_cost,bundles,bargaining_parameters,regulation_option,preferences,conglomerate_parameters);
        
    last_input_cost=test_input_costs;
   
    corresponding_channel=channel;
    save last_input_cost last_input_cost corresponding_channel
    
    
if (knitro==0)
    pre_f=sum(input_cost(list_of_conglomerate_channels,:)-test_input_costs(list_of_conglomerate_channels,:));  
    f=pre_f*pre_f';
elseif (knitro==1)
    f=sum(input_cost(list_of_conglomerate_channels,:)-test_input_costs(list_of_conglomerate_channels,:));  
end

disp ([sum(input_cost(list_of_conglomerate_channels,:)); sum(test_input_costs(list_of_conglomerate_channels,:))])
    
    
end
    
 
 
elseif (min(channel_bargaining_parameters)<0.000001)
 
    if (knitro==0)
    f=(min(channel_bargaining_parameters)-.000001)^2;
    elseif (knitro==1)
    f=(min(channel_bargaining_parameters,.000001)-.000001).^2;
    end
    
elseif (max(channel_bargaining_parameters)>0.999)
    if (knitro==0)
    f=(max(channel_bargaining_parameters)-.999)^2;
    elseif (knitro==1)
    f=(max(channel_bargaining_parameters,.999)-.999).^2;
    end
end