

[consumer_welfare_big_market consumer_welfare_small_market downstream_profits upstream_fee_revenue advertising_revenue time_watched market_share_big_market market_share_small_market consumer_buys_big_market consumer_buys_small_market prices]=bargaining_welfare_measures(bundles,input_cost,1,preferences);
consumer_welfare_big_market_bundling=consumer_welfare_big_market;
consumer_welfare_small_market_bundling=consumer_welfare_small_market;
mean_consumer_welfare_bundling = (mean(consumer_welfare_big_market)*market_size(1) + mean(consumer_welfare_small_market)*market_size(2))/sum(market_size);
downstream_aggregate_profits_bundling = sum(downstream_profits)/(length(beta_i_big_market)*sum(market_size));
upstream_aggregate_fee_revenue_bundling = sum(upstream_fee_revenue)/(length(beta_i_big_market)*sum(market_size));
upstream_aggregate_advertising_revenue_bundling = sum(advertising_revenue);

industry_profits_bundling = (sum(downstream_aggregate_profits_bundling)+sum(upstream_aggregate_fee_revenue_bundling)+sum(upstream_aggregate_advertising_revenue_bundling));


number_of_channels_purchased_big_market_bundling=49*sum(mean(market_share_big_market));
number_of_channels_purchased_small_market_bundling=49*sum(mean(market_share_small_market));  
number_of_channels_watched_big_market_bundling=mean(sum(wtp_distribution>0,2).*sum(market_share_big_market,2));
number_of_channels_watched_small_market_bundling=mean(sum(wtp_distribution>0,2).*sum(market_share_small_market,2));

mean_consumer_expenditure_bundling = (market_size(1)*mean(sum(market_share_big_market(:,1)*prices(1) + market_share_big_market(:,2)*prices(3) + market_share_big_market(:,3)*prices(4),2)) + market_size(2)*mean(sum(market_share_small_market(:,1)*prices(2) + market_share_small_market(:,2)*prices(3) + market_share_small_market(:,3)*prices(4),2)))/sum(market_size);
total_market_share_bundling=(market_size(1)*mean(sum(market_share_big_market(:,1) + market_share_big_market(:,2) + market_share_big_market(:,3),2)) + market_size(2)*mean(sum(market_share_small_market(:,1) + market_share_small_market(:,2) + market_share_small_market(:,3),2)))/sum(market_size);

% Naive ALC

[consumer_welfare_big_market consumer_welfare_small_market downstream_profits upstream_fee_revenue advertising_revenue time_watched market_share_big_market market_share_small_market consumer_buys_big_market consumer_buys_small_market prices]=bargaining_welfare_measures(bundles,input_cost,4,preferences);
mean_consumer_welfare_alc_naive = (mean(consumer_welfare_big_market)*market_size(1) + mean(consumer_welfare_small_market)*market_size(2))/sum(market_size);
downstream_aggregate_profits_alc_naive = sum(downstream_profits)/(length(beta_i_big_market)*sum(market_size));
upstream_aggregate_fee_revenue_alc_naive = sum(upstream_fee_revenue)/(length(beta_i_big_market)*sum(market_size));
upstream_aggregate_advertising_revenue_alc_naive = sum(advertising_revenue);
    
  number_of_channels_purchased_big_market_alc_naive=mean(sum(consumer_buys_big_market(:,:,1),2).*market_share_big_market(:,1,1) + ...
    sum(consumer_buys_big_market(:,:,2),2).*market_share_big_market(:,2,1) + ...
    sum(consumer_buys_big_market(:,:,3),2).*market_share_big_market(:,3,1) + ... 
    (sum(consumer_buys_big_market(:,:,1),2)-1).*market_share_big_market(:,1,2) + ...
    (sum(consumer_buys_big_market(:,:,2),2)-1).*market_share_big_market(:,2,2) + ...
    (sum(consumer_buys_big_market(:,:,3),2)-1).*market_share_big_market(:,3,2)); 
    
    number_of_channels_purchased_small_market_alc_naive=mean(sum(consumer_buys_small_market(:,:,1),2).*market_share_small_market(:,1,1) + ...
    sum(consumer_buys_small_market(:,:,2),2).*market_share_small_market(:,2,1) + ...
    sum(consumer_buys_small_market(:,:,3),2).*market_share_small_market(:,3,1) + ... 
    (sum(consumer_buys_small_market(:,:,1),2)-1).*market_share_small_market(:,1,2) + ...
    (sum(consumer_buys_small_market(:,:,2),2)-1).*market_share_small_market(:,2,2) + ...
    (sum(consumer_buys_small_market(:,:,3),2)-1).*market_share_small_market(:,3,2)); 

number_of_channels_purchased_alc_naive=(market_size(1)*number_of_channels_purchased_big_market_alc_naive + market_size(2)*number_of_channels_purchased_small_market_alc_naive)/sum(market_size);

total_market_share_alc_naive=(market_size(1)*mean(sum(sum(market_share_big_market,3),2))+market_size(2)*mean(sum(sum(market_share_small_market,3),2)))/sum(market_size);

prices_alc_naive=prices;

% Renegotiated input costs

load track_alc_cf_yen52

[consumer_welfare_big_market consumer_welfare_small_market downstream_profits upstream_fee_revenue advertising_revenue time_watched market_share_big_market market_share_small_market consumer_buys_big_market consumer_buys_small_market prices]=bargaining_welfare_measures(bundles,new_input_costs,4,preferences);

mean_consumer_welfare_alc = (mean(consumer_welfare_big_market)*market_size(1) + mean(consumer_welfare_small_market)*market_size(2))/sum(market_size);
downstream_aggregate_profits_alc = sum(downstream_profits)/(length(beta_i_big_market)*sum(market_size));
upstream_aggregate_fee_revenue_alc = sum(upstream_fee_revenue)/(length(beta_i_big_market)*sum(market_size));
upstream_aggregate_advertising_revenue_alc = sum(advertising_revenue);

    number_of_channels_purchased_big_market_alc=mean(sum(consumer_buys_big_market(:,:,1),2).*market_share_big_market(:,1,2) + ...
    sum(consumer_buys_big_market(:,:,2),2).*market_share_big_market(:,2,2) + ...
    sum(consumer_buys_big_market(:,:,3),2).*market_share_big_market(:,3,2) + ... 
    (sum(consumer_buys_big_market(:,:,1),2)-1).*market_share_big_market(:,1,1) + ...
    (sum(consumer_buys_big_market(:,:,2),2)-1).*market_share_big_market(:,2,1) + ...
    (sum(consumer_buys_big_market(:,:,3),2)-1).*market_share_big_market(:,3,1)); 
    
    number_of_channels_purchased_small_market_alc=mean(sum(consumer_buys_small_market(:,:,1),2).*market_share_small_market(:,1,2) + ...
    sum(consumer_buys_small_market(:,:,2),2).*market_share_small_market(:,2,2) + ...
    sum(consumer_buys_small_market(:,:,3),2).*market_share_small_market(:,3,2) + ... 
    (sum(consumer_buys_small_market(:,:,1),2)-1).*market_share_small_market(:,1,1) + ...
    (sum(consumer_buys_small_market(:,:,2),2)-1).*market_share_small_market(:,2,1) + ...
    (sum(consumer_buys_small_market(:,:,3),2)-1).*market_share_small_market(:,3,1)); 

number_of_channels_purchased_alc=(market_size(1)*number_of_channels_purchased_big_market_alc + market_size(2)*number_of_channels_purchased_small_market_alc)/sum(market_size);

prices_alc=prices;
total_market_share_alc=(market_size(1)*mean(sum(sum(market_share_big_market,3),2))+market_size(2)*mean(sum(sum(market_share_small_market,3),2)))/sum(market_size);

channel_market_shares=zeros(length(wtp_distribution(1,:)),1);
for k=1:length(wtp_distribution(1,:));

    if (k~=16)
    channel_market_shares(k) =  (market_size(1)*mean(consumer_buys_big_market(:,k,1).*(market_share_big_market(:,1,1)+market_share_big_market(:,1,2)) + consumer_buys_big_market(:,k,2).*(market_share_big_market(:,2,1)+market_share_big_market(:,2,2)) + consumer_buys_big_market(:,k,3).*(market_share_big_market(:,3,1)+market_share_big_market(:,3,2))) + ...
                                market_size(2)*mean(consumer_buys_small_market(:,k,1).*(market_share_small_market(:,1,1)+market_share_small_market(:,1,2)) + consumer_buys_small_market(:,k,2).*(market_share_small_market(:,2,1)+market_share_small_market(:,2,2)) + consumer_buys_small_market(:,k,3).*(market_share_small_market(:,3,1)+market_share_small_market(:,3,2))))/sum(market_size);                      
    else
    channel_market_shares(k) =  (market_size(1)*mean(consumer_buys_big_market(:,k,1).*(market_share_big_market(:,1,2)) + consumer_buys_big_market(:,k,2).*(market_share_big_market(:,2,2)) + consumer_buys_big_market(:,k,3).*(market_share_big_market(:,3,2))) + ...
                                market_size(2)*mean(consumer_buys_small_market(:,k,1).*(market_share_small_market(:,1,2)) + consumer_buys_small_market(:,k,2).*(market_share_small_market(:,2,2)) + consumer_buys_small_market(:,k,3).*(market_share_small_market(:,3,2))))/sum(market_size);
    end
end

% Themed Tiers - Renegotiated input costs
load tt_eq_costs
[consumer_welfare_big_market consumer_welfare_small_market downstream_profits upstream_fee_revenue advertising_revenue time_watched market_share_big_market market_share_small_market consumer_buys_big_market consumer_buys_small_market prices]=bargaining_welfare_measures(bundles,new_input_costs,3,preferences);


    consumer_welfare_big_market_tt=consumer_welfare_big_market;
    consumer_welfare_small_market_tt=consumer_welfare_small_market;
    mean_consumer_welfare_tt = (mean(consumer_welfare_big_market)*market_size(1) + mean(consumer_welfare_small_market)*market_size(2))/sum(market_size);
    downstream_aggregate_profits_tt = sum(downstream_profits)/(length(beta_i_big_market)*sum(market_size));
    upstream_aggregate_fee_revenue_tt = sum(upstream_fee_revenue)/(length(beta_i_big_market)*sum(market_size));
    upstream_aggregate_advertising_revenue_tt = sum(advertising_revenue);

    industry_profits_bundling_tt = (sum(downstream_aggregate_profits_tt)+sum(upstream_aggregate_fee_revenue_tt)+sum(upstream_aggregate_advertising_revenue_tt));

    p1=prices(:,1);
    p2=prices(:,2);
    p3=prices(:,3);
    p4=prices(:,4);

channels_per_package=sum(in_package,2);

pre_number_of_channels_purchased_big_market_tt=zeros(31,1);
pre_number_of_channels_purchased_small_market_tt=zeros(31,1);
for j=1:31
pre_number_of_channels_purchased_big_market_tt(j)=channels_per_package(j)*mean(sum(squeeze(market_share_big_market(:,j,:)),2));
pre_number_of_channels_purchased_small_market_tt(j)=channels_per_package(j)*mean(sum(squeeze(market_share_small_market(:,j,:)),2));
end

number_of_channels_purchased_big_market_tt=sum(pre_number_of_channels_purchased_big_market_tt);
number_of_channels_purchased_small_market_tt=sum(pre_number_of_channels_purchased_small_market_tt);

channels_watched_per_package=zeros(length(beta_i_big_market),31);
for k=1:length(beta_i_big_market)
for j=1:31
channels_watched_per_package(k,j)=sum(in_package(j,:).*(wtp_distribution(k,:)>0));
end

end
pre_number_of_channels_watched_big_market_tt=zeros(31,1);
pre_number_of_channels_watched_small_market_tt=zeros(31,1);
for j=1:31
pre_number_of_channels_watched_big_market_tt(j)=mean(channels_watched_per_package(:,j).*sum(squeeze(market_share_big_market(:,j,:)),2));
pre_number_of_channels_watched_small_market_tt(j)=mean(channels_watched_per_package(:,j).*sum(squeeze(market_share_small_market(:,j,:)),2));
end
number_of_channels_watched_big_market_tt=sum(pre_number_of_channels_watched_big_market_tt);
number_of_channels_watched_small_market_tt=sum(pre_number_of_channels_watched_small_market_tt);

number_of_channels_watched_tt=(market_size(1)*number_of_channels_watched_big_market_tt + market_size(2)*number_of_channels_watched_small_market_tt)/sum(market_size);

    for k=1:31
        p1_package(k)=p1(1:5)'*new_packages(k,:)';
        p2_package(k)=p2(1:5)'*new_packages(k,:)';
        p3_package(k)=p3(1:5)'*new_packages(k,:)';
        p4_package(k)=p4(1:5)'*new_packages(k,:)';
    end
    
    for i=1:length(beta_i_big_market)
    consumer_expenditure_big_market(i) = sum(market_share_big_market(i,:,1).*(p1_package+p1(6)) + market_share_big_market(i,:,2).*(p3_package+p3(6)) + market_share_big_market(i,:,3).*(p4_package+p4(6)));
    consumer_expenditure_small_market(i) = sum(market_share_small_market(i,:,1).*(p2_package+p2(6)) + market_share_small_market(i,:,2).*(p3_package+p3(6)) + market_share_small_market(i,:,3).*(p4_package+p4(6)));
    end
    
    mean_consumer_expenditure_tt = (market_size(1)*mean(consumer_expenditure_big_market) +  market_size(2)*mean(consumer_expenditure_small_market))/sum(market_size);
    
    wired_households_tt=(market_size(1)*mean(sum(sum(market_share_big_market,3),2))+market_size(2)*mean(sum(sum(market_share_small_market,3),2)))/sum(market_size);
    
    
    % BSP
    load track_bsp_cf_yen7
    [consumer_welfare_big_market consumer_welfare_small_market downstream_profits upstream_fee_revenue advertising_revenue time_watched market_share_big_market market_share_small_market consumer_buys_big_market consumer_buys_small_market prices]=bargaining_welfare_measures(bundles,new_input_costs,2,preferences);

    
    consumer_welfare_big_market_bsp=consumer_welfare_big_market;
    consumer_welfare_small_market_bsp=consumer_welfare_small_market;
    mean_consumer_welfare_bsp = (mean(consumer_welfare_big_market)*market_size(1) + mean(consumer_welfare_small_market)*market_size(2))/sum(market_size);
    downstream_aggregate_profits_bsp = sum(downstream_profits)/(length(beta_i_big_market)*sum(market_size));
    upstream_aggregate_fee_revenue_bsp = sum(upstream_fee_revenue)/(length(beta_i_big_market)*sum(market_size));
    upstream_aggregate_advertising_revenue_bsp = sum(advertising_revenue);

    industry_profits_bundling_bsp = (sum(downstream_aggregate_profits_bsp)+sum(upstream_aggregate_fee_revenue_bsp)+sum(upstream_aggregate_advertising_revenue_bsp));
  
    p1=prices(1:2);
    p2=prices(3:4);
    p3=prices(5:6);
    p4=prices(7:8);
    
    for i=1:length(beta_i_big_market)
    consumer_expenditure_big_market_bsp(i) = sum(market_share_big_market(i,1,1)*p1(1) + market_share_big_market(i,2,1)*p1(2) + market_share_big_market(i,1,2)*p3(1) + market_share_big_market(i,2,2)*p3(2) + market_share_big_market(i,1,3)*p4(1) + market_share_big_market(i,2,3)*p4(2));
    consumer_expenditure_small_market_bsp(i) = sum(market_share_small_market(i,1,1)*p1(1) + market_share_small_market(i,2,1)*p1(2) + market_share_small_market(i,1,2)*p3(1) + market_share_small_market(i,2,2)*p3(2) + market_share_small_market(i,1,3)*p4(1) + market_share_small_market(i,2,3)*p4(2));
    end
    
    channels_watched_total=sum(wtp_distribution>0,2);
    
    for i=1:length(beta_i_big_market)
    channels_watched_big_market_bsp(i) = sum(market_share_big_market(i,1,1)*15 + market_share_big_market(i,2,1)*channels_watched_total(i) + market_share_big_market(i,1,2)*15 + market_share_big_market(i,2,2)*channels_watched_total(i) + market_share_big_market(i,1,3)*15 + market_share_big_market(i,2,3)*channels_watched_total(i));
    channels_watched_small_market_bsp(i) = sum(market_share_small_market(i,1,1)*15 + market_share_small_market(i,2,1)*channels_watched_total(i) + market_share_small_market(i,1,2)*15 + market_share_small_market(i,2,2)*channels_watched_total(i) + market_share_small_market(i,1,3)*15 + market_share_small_market(i,2,3)*channels_watched_total(i));
    
    channels_received_big_market_bsp(i) = sum(market_share_big_market(i,1,1)*15 + market_share_big_market(i,2,1)*49 + market_share_big_market(i,1,2)*15 + market_share_big_market(i,2,2)*49 + market_share_big_market(i,1,3)*15 + market_share_big_market(i,2,3)*49);
    channels_received_small_market_bsp(i) = sum(market_share_small_market(i,1,1)*15 + market_share_small_market(i,2,1)*49 + market_share_small_market(i,1,2)*15 + market_share_small_market(i,2,2)*49 + market_share_small_market(i,1,3)*15 + market_share_small_market(i,2,3)*49);

    end
    
    channels_watched_bsp=(market_size(1)*mean(channels_watched_big_market_bsp)+market_size(2)*mean(channels_watched_small_market_bsp))/sum(market_size);
    channels_received_bsp=(market_size(1)*mean(channels_received_big_market_bsp)+market_size(2)*mean(channels_received_small_market_bsp))/sum(market_size);
    
    total_market_share_bsp= (market_size(1)*(mean(sum(market_share_big_market(:,:,1),2))+mean(sum(market_share_big_market(:,:,2),2))+mean(sum(market_share_big_market(:,:,3),2))) + market_size(2)*(mean(sum(market_share_small_market(:,:,1),2))+mean(sum(market_share_small_market(:,:,2),2))+mean(sum(market_share_small_market(:,:,3),2))))/sum(market_size);
    