function f=uni_bargaining_estimation_objective_function(channel_bargaining_parameter,channel,distributor,input_cost,bargaining_parameters,regulation_option,preferences,conglomerate_parameters,knitro)

conglomerate=conglomerate_parameters{1};
conglomerate_groups=conglomerate_parameters{2};
channel_to_conglomerate=conglomerate_parameters{3};


disp(['channel ' num2str(channel)])
disp(['distributor ' num2str(distributor)])
disp(['channel_bargaining_parameter ' num2str(channel_bargaining_parameter)])
     
if ((min(channel_bargaining_parameter)>0.001) && (max(channel_bargaining_parameter)<.999))

    if (conglomerate==0)
        bargaining_parameters(channel,distributor)=channel_bargaining_parameter;
    else
        bargaining_parameters(conglomerate_groups{channel_to_conglomerate(channel)},distributor)=repmat(channel_bargaining_parameter,length(conglomerate_groups{channel_to_conglomerate(channel)}),1);
    end
    
bundles=ones(size(input_cost));

try 
    load last_input_cost
    if (corresponding_channel~=channel)
        last_input_cost=input_cost;
    end
catch
    last_input_cost=input_cost;
end



if (conglomerate==0)
test_input_costs=bargaining_equilibrium(channel,last_input_cost,bundles,bargaining_parameters,regulation_option,preferences,conglomerate_parameters);

last_input_cost=test_input_costs;
corresponding_channel=channel;
save last_input_cost last_input_cost corresponding_channel

if (knitro==0)
pre_f=input_cost(channel,distributor)-test_input_costs(channel,distributor);
f=pre_f*pre_f';
elseif (knitro==1)
f=input_cost(channel,distributor)-test_input_costs(channel,distributor);  
end
disp ([input_cost(channel,distributor); test_input_costs(channel,distributor)])

else
    
    list_of_conglomerate_channels=conglomerate_groups{channel_to_conglomerate(channel)};
    
    test_input_costs=bargaining_equilibrium(channel,last_input_cost,bundles,bargaining_parameters,regulation_option,preferences,conglomerate_parameters);
        
    last_input_cost=test_input_costs;
   
    corresponding_channel=channel;
    save last_input_cost last_input_cost corresponding_channel
    
    
if (knitro==0)
    pre_f=sum(input_cost(list_of_conglomerate_channels,distributor)-test_input_costs(list_of_conglomerate_channels,distributor));  
    f=pre_f*pre_f';
elseif (knitro==1)
    f=sum(input_cost(list_of_conglomerate_channels,distributor)-test_input_costs(list_of_conglomerate_channels,distributor));  
end

disp ([sum(input_cost(list_of_conglomerate_channels,:)); sum(test_input_costs(list_of_conglomerate_channels,:))])
    
    
end
    
 
 
elseif (min(channel_bargaining_parameter)<0.005)
 
    if (knitro==0)
    f=(20*(min(channel_bargaining_parameter)-.005))^2;
    elseif (knitro==1)
    f=(min(channel_bargaining_parameter,.005)-.005).^2;
    end
    
elseif (max(channel_bargaining_parameter)>0.999)
    if (knitro==0)
    f=(20*(max(channel_bargaining_parameter)-.999))^2;
    elseif (knitro==1)
    f=(max(channel_bargaining_parameter,.999)-.999).^2;
    end
end