function da=bargaining_disagreement_payoffs(channel,pair,bundles,input_cost,regulation_option,preferences,conglomerate_parameters)

pause(0.01)

conglomerate=conglomerate_parameters{1};
conglomerate_groups=conglomerate_parameters{2};
channel_to_conglomerate=conglomerate_parameters{3};

if (conglomerate==0)

%downstream pricing equilibrium
if (regulation_option==1)
    try 
        load last_prices_bundling
    catch
    last_prices={sum(input_cost(:,1)),sum(input_cost(:,2)),sum(input_cost(:,3)),sum(input_cost(:,4))};
    end
 elseif (regulation_option==2)
    try 
    load last_prices_bsp
    catch
    p1=[15 40];
    p2=[15 40];
    p3=[15 40];
    p4=[15 40];
    last_prices={p1,p2,p3,p4};
    end
elseif (regulation_option==3)
    try 
    load last_prices_tt
    catch
    load start_tt_prices
    last_prices={p1,p2,p3,p4};
    end
elseif (regulation_option==4)
    try 
    load last_prices_alc
    catch
    last_prices={[input_cost(:,1);20],[input_cost(:,2);18],[input_cost(:,3);10],[input_cost(:,4);10]};
    end
    
    
end



if (regulation_option~=3)
[downstream_profits upstream_profits]=bargaining_downstream_equilibrium(last_prices,bundles,input_cost,regulation_option,preferences,channel);
elseif (regulation_option==3)
    [downstream_profits upstream_profits]=bargaining_downstream_equilibrium_tt(last_prices,bundles,input_cost,regulation_option,preferences,channel);
end

da=[downstream_profits(pair) upstream_profits(channel)];

else
    
    
if (regulation_option==1)
    last_prices={sum(input_cost(:,1)),sum(input_cost(:,2)),sum(input_cost(:,3)),sum(input_cost(:,4))};
elseif (regulation_option==2)
    last_prices={[15 40],[15 40],[15 30],[15 30]};
elseif (regulation_option==3)
    try 
    load last_prices_tt
    catch
    load start_tt_prices
    last_prices={p1,p2,p3,p4};
    end
elseif (regulation_option==4)
    last_prices={[input_cost(:,1);20],[input_cost(:,2);18],[input_cost(:,3);12],[input_cost(:,4);12]};
end

[downstream_profits upstream_profits]=bargaining_downstream_equilibrium(last_prices,bundles,input_cost,regulation_option,preferences,channel);

da=[downstream_profits(pair) sum(upstream_profits(conglomerate_groups{channel_to_conglomerate(channel)}))];

    
end 
