function [mediamark_household_data mediamark_household_data_max hh_demographics mediamark_has_cable_or_satellite wave]=create_households_from_individual_data(raw_mediamark,num_of_household_draws)

%mediamark=csvread('C:\Work\Research\Cable\Data Work\Data Reconciliation\Data Reconciliation version 2.0\Census Data\Microdata\mediamark.csv');
%age	hh_income	hhsize	sex	marital	number_of_chi~n	race	education	own_or_rent has_cable wave	short_id
% mediamark=[randsample(mediamark(:,1),62809) randsample(mediamark(:,2),62809) randsample(mediamark(:,3),62809) randsample(mediamark(:,4),62809) randsample(mediamark(:,5),62809)  ... 
%             randsample(mediamark(:,6),62809) randsample(mediamark(:,7),62809) randsample(mediamark(:,8),62809) randsample(mediamark(:,9),62809) randsample(mediamark(:,10),62809) ...
%             mediamark(raw_mediamark(:,1),1) mediamark(raw_mediamark(:,1),end)];
%create random demographics

% census=csvread('data/census.csv');
%hh_id_number	number_of_people_in_hh	age1-age8	sex1-sex8	marital1-marital8	educ1-educ8	race1-race8	number_of_chi~n	hh_income	own_or_rent
% age1 = 3
% sex1 = 11
% marital1 = 19
% educ1 = 27
% race1 = 35
% hhincome = 44

% save mediamark_census mediamark census

load mediamark_census

match=zeros(num_of_household_draws,7);
type_of_match=zeros(num_of_household_draws,7);
hh_demographics=zeros(num_of_household_draws,9);

pre_hh_draw=zeros(num_of_household_draws,1);
has_cable=zeros(num_of_household_draws,1);
wave=zeros(num_of_household_draws,1);

for k=1:num_of_household_draws
 
    % pick a household
    pre_hh_draw(k)=ceil(rand*(length(census(:,1))));
    hh_draw=pre_hh_draw(k);
    
    profile=[census(hh_draw,[3 44 2 11 19 43 35 27 45])
            census(hh_draw,[4 44 2 12 20 43 36 28 45])
            census(hh_draw,[5 44 2 13 21 43 37 29 45])
            census(hh_draw,[6 44 2 14 22 43 38 30 45])
            census(hh_draw,[7 44 2 15 23 43 39 31 45])
            census(hh_draw,[8 44 2 16 24 43 40 32 45])
            census(hh_draw,[9 44 2 17 25 43 41 33 45])];
      
    number_of_adults=sum(profile(:,1)~=0);    
    hh_demographics(k,:)=sum(profile(1:number_of_adults,:),1)./ number_of_adults  ;
        
    for m=1:number_of_adults  
        
    % Find all matches (if any) in mediamark data
    if (m==1)
    matches=min((mediamark(:,1:9)==ones(length(mediamark(:,1)),1)*profile(m,:))')';
    else
    matches=min([(mediamark(:,1:9)==ones(length(mediamark(:,1)),1)*profile(m,:)) mediamark(:,10)==has_cable(k)*ones(length(mediamark(:,1)),1) mediamark(:,11)==wave(k)*ones(length(mediamark(:,1)),1)]')';
    end
    
    % Indicate if there is a match
    has_match=max(matches);
    
    if (has_match==1)
    
        % If there is a match, randomly select one of them
        potential_list=mediamark(matches==1,end);      
        draw=ceil(rand*(length(potential_list)));
        
        if (m==1)
        has_cable(k)=mediamark(mediamark(:,end)==potential_list(draw),10);
        wave(k)=mediamark(mediamark(:,end)==potential_list(draw),11);
        end
        
        match(k,m)=potential_list(draw);
        
        type_of_match(k,m)=1;
    else
        
        % If there is no match, try to find close matches
            if (m>1)
            submatches=min([(mediamark(:,[1 4 5 7 8])==ones(length(mediamark(:,1)),1)*profile(m,[1 4 5 7 8])) mediamark(:,10)==has_cable(k)*ones(length(mediamark(:,1)),1) mediamark(:,11)==wave(k)*ones(length(mediamark(:,1)),1)]')';
            else
            submatches=min((mediamark(:,[1 4 5 7 8])==ones(length(mediamark(:,1)),1)*profile(m,[1 4 5 7 8]))')';
            end
            
            has_submatch=max(submatches);
        
            if (has_submatch==1)             
            distance_to_submatch= sum((mediamark(:,[2 3]) - ones(length(submatches),1)*profile(m,[2 3])).^2,2).^.5;
            closest_submatch=min(distance_to_submatch(submatches==1));
            
            % If there are close submatches, randomly choose one
            potential_submatch_list=mediamark(distance_to_submatch==closest_submatch & submatches==1,end);
            draw=ceil(rand*(length(potential_submatch_list)));
            
            if (m==1)
            has_cable(k)=mediamark(mediamark(:,end)==potential_submatch_list(draw),10);
            wave(k)=mediamark(mediamark(:,end)==potential_submatch_list(draw),11);
            end
            
            match(k,m)=potential_submatch_list(draw);            
            type_of_match(k,m)=2;
            
            else
            match(k,m)=mediamark(randi(length(mediamark(:,1))),end);            
            type_of_match(k,m)=3;                
            end
            
    end
    end
    disp(k)
end


%for each household, assemble viewership numbers
mediamark_household_data=zeros(num_of_household_draws,375);
mediamark_household_data_max=zeros(num_of_household_draws,375);
for k=1:length(match(:,1))
            for zzz=1:7
                if (match(k,zzz)~=0)
            find_indices(zzz)=find(raw_mediamark(:,1)==match(k,zzz));
                end
            end
    
    for j=3:377
            
    mediamark_household_data(k,j-2)=sum(raw_mediamark(find_indices,j));
    mediamark_household_data_max(k,j-2)=max(raw_mediamark(find_indices,j));
    end
    clear find_indices
end

mediamark_has_cable_or_satellite=has_cable;
    





